package nl.uvt.locator;

import java.net.URLEncoder;

import nu.xom.*;

public class IllRequestor {
	Document getDocument( QueryData pQ, LinkInfo linkInfo ){
		Element root = new Element("records");
		Document doc = new Document( root );
		LinkInfo li = generateLink( pQ, linkInfo );
		if ( li != null ){
			Node liNode = li.toRecordNode();
			root.appendChild( liNode );
		}
//		Locator.logger.debug(doc.toXML());
		return doc;
	}

	private LinkInfo generateLink(QueryData pQ, LinkInfo linkInfo ) {
		LinkInfo li = new LinkInfo();
		li.linkMethod = "ILL";
		String db = "";
		String genre = pQ.genre;
		String loanForm = "";
		if ( genre.equals("article")){
			db = "2.3";
		}
		else {
			db = "2.4";
		}
		if  ( genre.equals("article") ||  genre.equals("bookitem") || genre.equals("proceeding" ) ){
			loanForm = "C";
		}
		else {
			loanForm = "L";
		}
		String ppn = pQ.ppn.replaceAll(" ", "");
		boolean doFree = false;
		if ( ppn.equals("") ){
			ppn = "FREE";
			doFree = true;
		}
		li.generatedUrl = "http://picarta.pica.nl/request/FORM/DB=" + db +  "/FORCETT=HTML/REQUEST?PPN=" + ppn
			+ "&loanform=" + loanForm + "&LNG=EN&RAPRF=surffederation";
		if ( doFree ){
			try {
			if ( !pQ.genre.equals("") ) 
				li.generatedUrl += "&genre=" + genre;
			if ( !pQ.isbn.equals("") ) 
				li.generatedUrl += "&isbn=" + pQ.isbn;
			if ( !pQ.issn.equals("") ) 
				li.generatedUrl += "&issn=" + pQ.issn;
			if ( pQ.thVolume > 0  ) 
				li.generatedUrl += "&volume=" + pQ.volume;
			if ( !pQ.issue.equals(""))
				li.generatedUrl += "&issue=" + pQ.issue;
			if ( !pQ.spage.equals(""))
				li.generatedUrl += "&spage=" + pQ.spage;
			if ( !pQ.pages.equals("") )
				li.generatedUrl += "&pages=" + pQ.pages;
			if ( !pQ.aulast.equals("") )
				li.generatedUrl += "&aulast=" + pQ.aulast;
			if ( !pQ.aufirst.equals("") )
				li.generatedUrl += "&aufirst=" + pQ.aufirst;
			if ( !pQ.auinit1.equals("") )
				li.generatedUrl += "&auinit1=" + pQ.auinit1;
			if ( !pQ.atitle.equals("") )
				li.generatedUrl += "&atitle=" + URLEncoder.encode( pQ.atitle, "ISO-8859-1" );
			if ( !pQ.title.equals("") )
				li.generatedUrl += "&title=" + URLEncoder.encode( pQ.title, "ISO-8859-1" );
			if ( !pQ.publisher.equals("") )
				li.generatedUrl += "&publisher=" + URLEncoder.encode( pQ.publisher, "ISO-8859-1" );
			if ( !pQ.placepub.equals("") )
				li.generatedUrl += "&placepub=" + URLEncoder.encode( pQ.placepub, "ISO-8859-1" );
			if ( pQ.year > 0 )
				li.generatedUrl += "&date=" + pQ.year;
			}
			catch( Exception e){
				Locator.logger.warn("Url generation failed on encoding problem." + e.getMessage() );
			}
			li.generatedUrl += "&dolocate=YES";
		}
		Locator.logger.debug("ILLlink:" + li.generatedUrl);		
		return li;
	}

}
